unit mainu;

{$warn UNIT_PLATFORM off}
{$warn SYMBOL_PLATFORM off}
{$warn UNSAFE_CODE off}
{$warn UNSAFE_TYPE off}
{$warn UNSAFE_CAST off}
// Copyright  1999, 2002 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, AppEvnts, Menus, ImgList, ActnList, StdCtrls,
  ComCtrls, ToolWin, ExtCtrls, sharedu;

type
  TListView = class(ComCtrls.TListView)
  private
    procedure WMDropFiles(VAR Msg: TWMDropFiles); message WM_DROPFILES;
  end;
  TDateTimePicker = class(ComCtrls.TDateTimePicker)
  private
    procedure WMDropFiles(VAR Msg: TWMDropFiles); message WM_DROPFILES;
  end;

  TMainForm = class(TForm)
    alMain           : TActionList;
      // Date/time category
        acNow        : TAction;
        acZerSec     : TAction;
        acZerMin     : TAction;
        acClkFmFile  : TAction;
        acSeq        : TAction;
        acDate       : TAction;
        acTime       : TAction;
      // Files category
        acSelect     : TAction;
        acRemove     : TAction;
        acClear      : TAction;
        acExit       : TAction;
      // Help category
        acHelp       : TAction;
        acAbout      : TAction;
      // Labels category
        acLblA       : TAction;
        acLblS       : TAction;
        acLblH       : TAction;
        acLblR       : TAction;
        acLblM       : TAction;
        acLblC       : TAction;
      // List items category
        acItemUp     : TAction;
        acItemDown   : TAction;
        acSelAll     : TAction;
      // Preset apply category
        preA1        : TAction;
        preA2        : TAction;
        preA3        : TAction;
        preA4        : TAction;
        preA5        : TAction;
      // Preset config category
        preC1        : TAction;
        preC2        : TAction;
        preC3        : TAction;
        preC4        : TAction;
        preC5        : TAction;
      // Preset menu category
        preM1        : TAction;
        preM2        : TAction;
        preM3        : TAction;
        preM4        : TAction;
        preM5        : TAction;
      // Preset remove category
        preR1        : TAction;
        preR3        : TAction;
        preR4        : TAction;
        preR5        : TAction;
        preR2        : TAction;
      // Touch category
        acReset      : TAction;
        acApply      : TAction;
        acUndoTouch  : TAction;
    pmList           : TPopupMenu;
      popSelect      : TMenuItem;
      popRemove      : TMenuItem;
      popClear       : TMenuItem;
      Sep1           : TMenuItem;
      popItemUp      : TMenuItem;
      popItemDown    : TMenuItem;
      popSelAll      : TMenuItem;
    pmPre1           : TPopupMenu;
      pop1A          : TMenuItem;
      pop1C          : TMenuItem;
      pop1R          : TMenuItem;
    pmPre2           : TPopupMenu;
      pop2A          : TMenuItem;
      pop2C          : TMenuItem;
      pop2R          : TMenuItem;
    pmPre3           : TPopupMenu;
      pop3A          : TMenuItem;
      pop3C          : TMenuItem;
      pop3R          : TMenuItem;
    pmPre4           : TPopupMenu;
      pop4A          : TMenuItem;
      pop4C          : TMenuItem;
      pop4R          : TMenuItem;
    pmPre5           : TPopupMenu;
      pop5A          : TMenuItem;
      pop5C          : TMenuItem;
      pop5R          : TMenuItem;
    pnlControl       : TPanel;
      gbFiles        : TGroupBox;
        lblFilA      : TLabel;
        tbFiles      : TToolBar;
          tbSelect   : TToolButton;
          tbRemove   : TToolButton;
          tbClear    : TToolButton;
        lblFilT      : TLabel;
          tbTouch    : TToolBar;
            tbApply  : TToolButton;
            tbUndo   : TToolButton;
            tbReset  : TToolButton;
      gbAttr         : TGroupBox;
        lblA         : TLabel;
        tbAttrA      : TToolBar;
          tbAminus   : TToolButton;
          tbAPlus    : TToolButton;
        lblS         : TLabel;
        tbAttrS      : TToolBar;
          tbSMinus   : TToolButton;
          tbSPlus    : TToolButton;
        lblH         : TLabel;
        tbAttrH      : TToolBar;
          tbHMinus   : TToolButton;
          tbHPlus    : TToolButton;
        lblR         : TLabel;
        tbAttrR      : TToolBar;
          tbRMinus   : TToolButton;
          tbRPlus    : TToolButton;
      gbSettings     : TGroupBox;
        lblM         : TLabel;
        tbMod        : TToolBar;
          tbModFmClk : TToolButton;
          tbModFmCre : TToolButton;
          tbModFmFld : TToolButton;
        lblC         : TLabel;
        tbCre        : TToolBar;
          tbCreFmClk : TToolButton;
          tbCreFmMod : TToolButton;
          tbCreFmFld : TToolButton;
      gbDateTime     : TGroupBox;
        cbDatex      : TCheckBox;
        DTDateMod    : TDateTimePicker;
        cbTimex      : TCheckBox;
        DTTimeMod    : TDateTimePicker;
        tbClkA       : TToolBar;
          tbClkFmFile: TToolButton;
          tbNow      : TToolButton;
        tbClkB       : TToolBar;
          tbZerMin   : TToolButton;
          tbZerSec   : TToolButton;
        cbSeq        : TCheckBox;
        comSeqN      : TComboBox;
        comSeqU      : TComboBox;
      tbPresets      : TToolBar;
        tbPre1       : TToolButton;
        tbPre2       : TToolButton;
        tbPre3       : TToolButton;
        tbPre4       : TToolButton;
        tbPre5       : TToolButton;
      btnHelp        : TButton;
      btnAbout       : TButton;
      btnExit        : TButton;
    lvMain           : TListView;
    sbMain           : TStatusBar;
    ilList           : TImageList;
    ilAction         : TImageList;
    ilStates         : TImageList;
    odSelect         : TOpenDialog;
    odClock          : TOpenDialog;
    aeMain           : TApplicationEvents;
    ilHStates: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acNowExecute(Sender: TObject);
    procedure acZerSecExecute(Sender: TObject);
    procedure acZerMinExecute(Sender: TObject);
    procedure acClkFmFileExecute(Sender: TObject);
    procedure acDateExecute(Sender: TObject);
    procedure acTimeExecute(Sender: TObject);
    procedure acSeqExecute(Sender: TObject);
    procedure acRemoveUpdate(Sender: TObject);
    procedure aSelectClick(Sender: TObject);
    procedure acRemoveExecute(Sender: TObject);
    procedure acClearExecute(Sender: TObject);
    procedure acExitExecute(Sender: TObject);
    procedure acHelpExecute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure acLabelsExecute(Sender: TObject);
    procedure acItemDownUpdate(Sender: TObject);
    procedure acItemDownExecute(Sender: TObject);
    procedure acItemUpExecute(Sender: TObject);
    procedure acSelAllExecute(Sender: TObject);
    procedure preA_AllExecute(Sender: TObject);
    procedure preC_AllExecute(Sender: TObject);
    procedure preM_AllExecute(Sender: TObject);
    procedure preR_AllExecute(Sender: TObject);
    procedure acApplyUpdate(Sender: TObject);
    procedure acApplyExecute(Sender: TObject);
    procedure acUndoTouchExecute(Sender: TObject);
    procedure acResetExecute(Sender: TObject);
    procedure LabelsClick(Sender: TObject);
    procedure DTDateModDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DTDateModDragDrop(Sender, Source: TObject;
      X, Y: Integer);
    procedure comSeqNChange(Sender: TObject);
    procedure tbPreAll(Sender: TObject);
    procedure lvMainColumnClick(Sender: TObject;
      Column: TListColumn);
    procedure lvMainCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState;
      var DefaultDraw: Boolean);
    procedure lvMainDragOver(Sender, Source: TObject;
      X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure lvMainDragDrop(Sender, Source: TObject;
      X, Y: Integer);
    procedure lvMainInfoTip(Sender: TObject; Item: TListItem;
      var InfoTip: String);
    procedure lvMainSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvMainStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure aeMainHint(Sender: TObject);
    procedure aeMainSettingChange(Sender: TObject; Flag: Integer;
      const Section: String; var Result: Integer);
    procedure FlyoverMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
  private
    { Private declarations }
    Busy       : Boolean;      // True when busy processing files
    ColExtra   : Integer;      // Added to colwidths for italic
    DupeList   : TStringList;  // Prevents adding duplicate files
    Dragee     : TListItem;    // Item being dragged
    FirstTime  : Boolean;      // For initialization in FormActivate
    IniName    : String;       // Name of INI file
    MinWid     : Integer;      // Form's minimum width
    SeqValue   : Integer;      // Sequential increment, in seconds
    SortCol    : Integer;      // Current sort-column, 1-based
    WasFolder  : String;       // Folder for from-file comparison
    preBtns : ARRAY[1..5] OF TToolButton; // Preset buttons
    prePops : ARRAY[1..5] OF TPopupMenu;  // Preset popup menus
    preApps : ARRAY[1..5] OF TAction;     // Apply actions
    preCnfs : ARRAY[1..5] OF TAction;     // Configure actions
    preRems : ARRAY[1..5] OF TAction;     // Remove actions
    procedure AddAnItem(const filename : String; vCreTime,
      vModTime : TFileTime; vAttr : DWord);
    function Ask(mbHandle : HWnd; total, pMatch, fMatch, mMatch,
      xMatch: Integer; const WasFolder : String;  vMod,
      vCre : Boolean; VAR UnSelect : Integer) : Boolean;
    procedure CheckShared;
    procedure ClockFromFile(const filename : String);
    procedure EnDisDateTime;
    procedure FixColumns;
    procedure NoSortCol;
    procedure SetBusy(value : Boolean);
    procedure SetColImage(LV : TListView; col, Idx : Integer);
    function ZerTime(T : TDateTime; MinToo : Boolean) : TDateTime;
    procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
      message WM_GETMINMAXINFO;
    procedure WM_HELP(var Msg : TWMHelp); message WM_HELP;
    procedure WM_HEYYOU(var Msg : TMessage); message WM_HEYYOU;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses inifiles, strutils, shellapi, commctrl, AboutBox, formposu,
  tfuncsu, tfuncs2, ftobju, presetu;

{$R *.DFM}

const
  c_name    = 0;
  c_mod     = 1;
  c_cre     = 2;
  c_att     = 3;
  c_path    = 4;

procedure TMainForm.FormCreate(Sender: TObject);
VAR
  S     : String;
  fName : String;
  fDesc : String;
  N     : Integer;
  any   : Boolean;

  procedure InitVars;
  // Initialized various data fields and variables
  begin
    Busy                 := False;
    FirstTime            := True;
    MinWid               := btnExit.Left + btnExit.Width + 16;
    // Force 4-digit year, 2-digit month, day, hour
    DTDateMod.Format     := DateFmt;
    DTTimeMod.Format     := TimeFmt;
    SeqValue             := 60;
    cbSeq.Caption        := '';
    cbDateX.Caption      := '';
    cbTimeX.Caption      := '';
    WITH Application DO
      begin
        HelpFile         := ChangeFileExt(ExeName, '.HLP');
        IniName          := ChangeFileExt(ExeName, '.INI');
      end;
    DupeList            := TStringList.Create;
    DupeList.Sorted     := True;
    DupeList.Duplicates := dupIgnore;
  end;

  procedure LoadImageLists;
  // By storing images as resources and loading them into their image
  // lists at run time, we save space and also avoid problems with
  // older versions of common controls
  begin
    LoadImageList(ilAction, 10, 23);
    LoadImageList(ilStates, 30, 35);
    LoadImageList(ilHStates, 36, 41);
    LoadImageList(ilList, 45, 50);
  end;

  procedure InitArrays;
  // FileTouch uses a number of five-member arrays of controls in
  // connection with the five presets. This routine organizes the
  // controls into their arrays.
  VAR N : Integer;
  begin
    FOR N := 1 TO 5 DO
      begin
        preApps[N] := FindComponent(Format('preA%d', [N]))
          AS TAction;
        preCnfs[N] := FindComponent(Format('preC%d', [N]))
          AS TAction;
        preRems[N] := FindComponent(Format('preR%d', [N]))
          AS TAction;
        prePops[N] := FindComponent(Format('pmPre%d', [N]))
          AS TPopupMenu;
        preBtns[N] := FindComponent(Format('tbPre%d', [N]))
          AS TToolButton;
      end;
  end;

begin
  InitVars;
  LoadImageLists;
  InitArrays;
  GetPosFmINI(IniName, Self, True);
  // Now load information from the INI file
  WITH TIniFile.Create(IniName) DO
  try
    // First get the presets
    REPEAT
      any := False;
      FOR N := 1 TO 5 DO
        IF ReadBool(Format('Preset%d',[N]), 'Enabled', False) THEN
          begin
            any := True;
            fName := ReadString(Format('Preset%d', [N]), 'Name',
              Format('Preset %d', [N]));
            fDesc := ReadString(Format('Preset%d', [N]), 'Desc',
                Format('Apply commands from preset #%d',[N]));
            fDesc := Format('Preset %d - %s', [N, fDesc]);
            preApps[N].Hint             := fName + '|' + fDesc;
            preApps[N].Enabled          := True;
            preRems[N].Enabled          := True;
            prePops[N].Items[0].Default := True;
            preBtns[N].ImageIndex       := preA1.ImageIndex;
            preBtns[N].Hint             := preApps[N].Hint;
          end;
      // If any exist, we're done
      IF any THEN Break;
      // If NO presets are stored, create a pair of examples
      S := 'Preset1';
      WriteString (S, 'Name',    'Sample: simple touch');
      WriteString (S, 'Desc',    'Set Modified and Created from '+
        'current date/time');
      WriteInteger(S, 'Clock',   0);
      WriteInteger(S, 'Enabled', 1);
      WriteInteger(S, 'Mod',     1);
      WriteInteger(S, 'Cre',     1);
      S := 'Preset2';
      WriteString (S, 'Name',    'Sample: fix copy');
      WriteString (S, 'Desc',    'Set Created from Modified and '+
        'remove read-only (useful after copy)');
      WriteInteger(S, 'Enabled', 1);
      WriteInteger(S, 'AttrR',   1);
      WriteInteger(S, 'Cre',     2);
    UNTIL False;
    // Now get other settings
    acDate.Checked := ReadBool('Settings', 'ChangeDate', True);
    acTime.Checked := ReadBool('Settings', 'ChangeTime', True);
    acSeq.Checked  := ReadBool('Settings', 'Sequential', False);
    EnDisDateTime;
    WasFolder := ReadString('Settings', 'WasFolder',
      ExtractFileDir(Application.Exename));
    comSeqN.ItemIndex := ReadInteger('Settings', 'SeqNumber', 0);
    comSeqU.ItemIndex := ReadInteger('Settings', 'SeqUnit', 0);
    comSeqNChange(comSeqN);
    S := ReadString('Location', 'Location',
      ExtractFilePath(Application.ExeName));
    IF S = '' THEN S := ExtractFilePath(Application.ExeName);
    odSelect.InitialDir := IncludeTrailingBackslash(S);
    DTDateMod.Date := ReadDate('Settings', 'ClockDate', Now);
    DTTimeMod.Time := ReadTime('Settings', 'ClockTime', Now);
  finally
    Free;
  end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
// Some initialization has to wait until the form has been displayed
VAR dummy : Integer;
begin
  IF FirstTime THEN // FirstTime gets cleared in aeMainSettingChange
    begin
      Show;
      FillChar(dummy, SizeOf(dummy), 0);
      // This activates the code that gets the messagebox font
      // for the richedit and the icon title font for the listview
      aeMainSettingChange(aeMain, 0, '', Dummy);
      lvMain.Perform(CM_FONTCHANGED, 0, 0);
      DragAcceptFiles(DTDateMod.Handle, True);
      DragAcceptFiles(DTTimeMod.Handle, True);
      DragAcceptFiles(lvMain.Handle,    True);
      aeMainHint(aeMain);
      CheckShared;
    end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  DupeList.Free;
  DragAcceptFiles(lvMain.Handle, False);
  DragAcceptFiles(DTDateMod.Handle, False);
  DragAcceptFiles(DTTimeMod.Handle, False);
  SetPosToINI(IniName, Self, True);
  // Save non-preset settings
  WITH TIniFile.Create(IniName) DO
  try
    WriteBool   ('Settings', 'ChangeDate', acDate.Checked);
    WriteBool   ('Settings', 'ChangeTime', acTime.Checked);
    WriteBool   ('Settings', 'Sequential', acSeq.Checked);
    WriteInteger('Settings', 'SeqNumber',  comSeqN.ItemIndex);
    WriteInteger('Settings', 'SeqUnit',    comSeqU.ItemIndex);
    WriteDate   ('Settings', 'ClockDate',  DTDateMod.Date);
    WriteTime   ('Settings', 'ClockTime',  DTTimeMod.Time);
    WriteString ('Location', 'Location',   odSelect.InitialDir);
    WriteString ('Settings', 'WasFolder',  WasFolder);
  finally
    Free;
  end;
end;

procedure TMainForm.acNowExecute(Sender: TObject);
begin
  DTDateMod.DateTime := Now;
  DTTimeMod.DateTime := Now;
end;

procedure TMainForm.acZerSecExecute(Sender: TObject);
begin
  DTTimeMod.DateTime := ZerTime(DTTimeMod.DateTime, False);
end;

procedure TMainForm.acZerMinExecute(Sender: TObject);
begin
  DTTimeMod.DateTime := ZerTime(DTTimeMod.DateTime, True);
end;

procedure TMainForm.acClkFmFileExecute(Sender: TObject);
begin
  WITH odClock DO
    IF Execute THEN
      ClockFromFile(Filename);
end;

procedure TMainForm.acDateExecute(Sender: TObject);
begin
  WITH Sender AS TAction DO
    begin
      Checked := NOT Checked;
      EnDisDateTime;
      // You can't activeate the date/time picker from the keyboard,
      // so we give it the focus automatically after you check the
      // box that enables it.
      IF Checked AND DTDateMod.Enabled THEN DTDateMod.SetFocus;
    end;
end;

procedure TMainForm.acTimeExecute(Sender: TObject);
begin
  WITH Sender AS TAction DO
    begin
      Checked := NOT Checked;
      EnDisDateTime;
      // You can't activeate the date/time picker from the keyboard,
      // so we give it the focus automatically after you check the
      // box that enables it.
      IF Checked AND DTTimeMod.Enabled THEN DTTimeMod.SetFocus;
    end;
end;

procedure TMainForm.acSeqExecute(Sender: TObject);
begin
  WITH Sender AS TAction DO
    begin
      Checked := NOT Checked;
      EnDisDateTime;
    end;
end;

procedure TMainForm.acRemoveUpdate(Sender: TObject);
begin
  acRemove.Enabled := (NOT BUSY) AND (lvMain.SelCount > 0);
  acClear.Enabled  := (NOT BUSY) AND (lvMain.Items.Count > 0);
end;

procedure TMainForm.aSelectClick(Sender: TObject);
VAR
  N       : Integer;
  CreTime : TFileTime;
  ModTime : TFileTime;
  Attr    : DWORD;
  Errs    : TStringList;
  Drive   : String;
  Mapped  : String;
  Msg     : String;
begin
  // An invalid filename can "gag" the File Open dialog. To avoid
  // that, we check for existence before calling Execute.
  IF NOT FileExists(odSelect.Filename) THEN
    odSelect.Filename := '';
  WITH odSelect DO
    IF Execute THEN
      begin
        Drive := IncludeTrailingBackslash(ExtractFileDrive(
          Filename));
        CASE GetDriveType(PChar(Drive)) OF
          DRIVE_REMOTE : begin
            Mapped := GetRemote(Drive);
            IF Mapped = Drive THEN
              Msg := Format('You have selected files from the '+
                'Network drive "%s". FileTouch only works with '+
                'files on local drives. Please run FileTouch on '+
                'the machine that contains the drive identified '+
                'as "%s".',[Drive, Drive])
            ELSE
              Msg := Format('You have selected files from the '+
                'Network drive "%s", mapped to "%s" on your '+
                'system. FileTouch only works with files on local '+
                'drives. Please run FileTouch on the machine that '+
                'contains the drive identified as "%0:s".',[Mapped,
                Drive]);
            MessageBox(Self.Handle, PChar(Msg),
              PChar(Application.Title), MB_OK OR MB_ICONSTOP);
            Exit;
          end;
          DRIVE_CDROM : begin
            Msg := Format('You have selected files from the '+
              'CD-ROM drive "%s". FileTouch cannot modify files '+
              'on a CD-ROM.',[Drive]);
            MessageBox(Self.Handle, PChar(Msg),
              PChar(Application.Title), MB_OK OR MB_ICONSTOP);
            Exit;
          end;
        END;
        InitialDir    := ExtractFilePath(Filename);
        Errs          := TStringList.Create;
        Screen.Cursor := crHourglass;
        SetBusy(True);
        try
          FOR N := 0 TO Files.Count-1 DO
            begin
              IF NOT GetFileDateTimes(Files[N], CreTime, ModTime,
                Attr) THEN
                  Errs.Add(#9+Files[N])
              ELSE AddAnItem(Files[N], CreTime, ModTime, Attr);
            end;
          IF Errs.Count > 0 THEN
            begin
              IF Errs.Count < 20 THEN
                MessageBox(Self.Handle, PChar(Format('FileTouch '+
                  'was unable to select the following %d files:'+
                  #13#10#13#10'%s'#13#10'These files may be in use '+
                  'by the system or by another process.', [Errs.Count,
                  Errs.Text])), PChar(Application.Title),
                  MB_OK OR MB_ICONSTOP)
              ELSE
                MessageBox(Self.Handle, PChar(Format('FileTouch '+
                  'was unable to select %d of the specified files.'+
                  #13#10'These files may be in use by the system '+
                  'or by another process.', [Errs.Count, Errs.Text])),
                  PChar(Application.Title), MB_OK OR MB_ICONSTOP);
            end;
          NoSortCol;
        finally
          Errs.Free;
          Screen.Cursor := crDefault;
          SetBusy(False);
        end;
      end;
  FixColumns;
end;

procedure TMainForm.acRemoveExecute(Sender: TObject);
// Remove selected items from the list. Also remove from the internal
// list that avoids duplicates
VAR
  N   : Integer;
  Idx : Integer;
  TFT : TFTObj;
begin
  FOR N := lvMain.Items.Count-1 DOWNTO 0 DO
    IF lvMain.Items[N].Selected THEN
      begin
        TFT := TftObj(lvMain.Items[N].Data);
        Idx := DupeList.IndexOf(TFT.Filename);
        IF Idx >= 0 THEN DupeList.Delete(Idx);
        TFT.Free;
        lvMain.Items.Delete(N);
      end;
end;

procedure TMainForm.acClearExecute(Sender: TObject);
// Clear listview, duplicate list
VAR N : Integer;
begin
  FOR N := lvMain.Items.Count-1 DOWNTO 0 DO
    begin
      TftObj(lvMain.Items[N].Data).Free;
      lvMain.Items.Delete(N);
    end;
  DupeList.Clear;  
  FixColumns;
end;

procedure TMainForm.acExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.acHelpExecute(Sender: TObject);
begin
  WinHelp(Self.Handle, PChar(Application.HelpFile), HELP_FINDER, 0);
end;

procedure TMainForm.acAboutExecute(Sender: TObject);
begin
  WITH TAboutForm.Create(Self) DO
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.acLabelsExecute(Sender: TObject);
// Clicking the labels for the six one-or-none toolbars cycles thru
// the available buttons
begin
  CASE (Sender AS TAction).Tag OF
    1 : CycleButtons(tbMod);
    2 : CycleButtons(tbCre);
    3 : CycleButtons(tbAttrA);
    4 : CycleButtons(tbAttrS);
    5 : CycleButtons(tbAttrH);
    6 : CycleButtons(tbAttrR);
  END;
end;

procedure TMainForm.acItemDownUpdate(Sender: TObject);
// When exactly one item is selected, you can move it up or down
begin
  IF (NOT BUSY) AND (lvMain.SelCount = 1) THEN
    begin
      acItemUp.Enabled   := lvMain.Selected.Index > 0;
      acItemDown.Enabled := lvMain.Selected.Index <
        lvMain.Items.Count-1;
    end
  ELSE
    begin
      acItemUp.Enabled   := False;
      acItemDown.Enabled := False;
    end;
  acSelAll.Enabled       := (NOT BUSY) AND (lvMain.Items.Count > 0);
end;

procedure TMainForm.acItemDownExecute(Sender: TObject);
// You can't literally move a list item when the syle is vsReport.
// Instead you must insert a copy at the desired location and
// delete the original.
VAR Was : TListItem;
begin
  Was := lvMain.Selected;
  WITH lvMain.Items.Insert(Was.Index+2) DO
    begin
      Assign(lvMain.Selected);
      Selected := True;
      Focused  := True;
    end;
  Was.Delete;
  NoSortCol;
end;

procedure TMainForm.acItemUpExecute(Sender: TObject);
// You can't literally move a list item when the syle is vsReport.
// Instead you must insert a copy at the desired location and
// delete the original.
VAR Was : TListItem;
begin
  Was := lvMain.Selected;
  WITH lvMain.Items.Insert(Was.Index-1) DO
    begin
      Assign(lvMain.Selected);
      Selected := True;
      Focused := True;
    end;
  Was.Delete;
  NoSortCol;
end;

procedure TMainForm.acSelAllExecute(Sender: TObject);
begin
  lvMain.SelectAll;
end;

procedure TMainForm.preA_AllExecute(Sender: TObject);
// Method shared by the Apply command for all presets
VAR Sec : String;
  procedure ButtonOne(num : Integer; Btns : ARRAY OF TToolButton);
  VAR N : Integer;
  begin
    IF num < Low(Btns)  THEN Exit;
    IF num > High(Btns) THEN Exit;
    FOR N := Low(Btns) TO High(Btns) DO
      IF Btns[N] = nil THEN Continue
      ELSE IF N=num THEN
        Btns[N].Down := True
      ELSE Btns[N].Down := False;
  end;

begin
  Sec := Format('Preset%d', [(Sender AS TAction).Tag]);
  WITH TIniFile.Create(ininame) DO
  try
    CASE ReadInteger(sec, 'Clock', 0) OF
      0 : acNowExecute(acNow);
      1 : begin
        acNowExecute(acNow);
        acZerSecExecute(acZerSec);
      end;
      2 : begin
        acNowExecute(acNow);
        acZerMinExecute(acZerSec);
      end;
      ELSE begin
        DTDateMod.Date := ReadDate(sec, 'Date', Now);
        DTTimeMod.Time := ReadTime(sec, 'Time', Now);
      end;
    END;
    acDate.Checked := ReadBool(sec, 'UseDate', True);
    acTime.Checked := ReadBool(sec, 'UseTime', True);
    acSeq.Checked  := ReadBool(sec, 'UseSeq', False);
    EnDisDateTime;
    comSeqN.ItemIndex := ReadInteger(sec, 'SeqNum', 0);
    comSeqU.ItemIndex := ReadInteger(sec, 'SeqUnit', 0);
    ButtonOne(ReadInteger(sec, 'Mod', 0),
      [nil, tbModFmClk, tbModFmCre, tbModFmFld]);
    ButtonOne(ReadInteger(sec, 'Cre', 0),
      [nil, tbCreFmClk, tbCreFmMod, tbCreFmFld]);
    ButtonOne(ReadInteger(sec, 'AttrA', 0),
      [nil, tbAMinus, tbAPlus]);
    ButtonOne(ReadInteger(sec, 'AttrS', 0),
      [nil, tbSMinus, tbSPlus]);
    ButtonOne(ReadInteger(sec, 'AttrH', 0),
      [nil, tbHMinus, tbHPlus]);
    ButtonOne(ReadInteger(sec, 'AttrR', 0),
      [nil, tbRMinus, tbRPlus]);
  finally
    Free;
  end;
end;

procedure TMainForm.preC_AllExecute(Sender: TObject);
// Method shared by the Configure command for all presets
VAR
  which : Integer;
  fName, fDesc : String;
begin
  which := (Sender AS TAction).Tag;
  WITH PresetForm DO
    begin
      SetData(which);
      IF ShowModal = mrOK THEN
        begin
          GetData(fName, fDesc);
          fDesc := Format('Preset %d - %s', [which, fDesc]);
          preApps[which].Hint             := fName + '|' + fDesc;
          preApps[which].Enabled          := True;
          preRems[which].Enabled          := True;
          preBtns[which].ImageIndex       := preA1.ImageIndex;
          preBtns[which].Hint             := preApps[which].Hint;
          prePops[which].Items[0].Default := True;
        end;
    end;
end;

procedure TMainForm.preM_AllExecute(Sender: TObject);
// Method shared by all of the actions that display preset menus
begin
  preBtns[(Sender AS TAction).Tag].CheckMenuDropdown;
end;

procedure TMainForm.preR_AllExecute(Sender: TObject);
// Method shared by the Remove commands for all presets
VAR which : Integer;
begin
  which := (Sender AS TAction).Tag;
  WITH TIniFile.Create(ininame) DO
  try
    EraseSection(Format('Preset%d',[which]))
  finally
    Free;
  end;
  preApps[which].Hint := Format('Apply preset %d|Apply settings '+
    'from preset #%d', [which, which]);
  preApps[which].Enabled          := False;
  preRems[which].Enabled          := False;
  preBtns[which].ImageIndex       := preC1.ImageIndex;
  prePops[which].Items[1].Default := True;
  preBtns[which].Hint             := prePops[which].Items[1].Hint;
end;

procedure TMainForm.acApplyUpdate(Sender: TObject);
VAR N : Integer;
begin
  acApply.Enabled := (NOT BUSY) AND (lvMain.SelCount > 0) AND
    (tbModFmClk.Down OR tbModFmCre.Down OR tbModFmFld.Down OR
    tbCreFmClk.Down OR tbCreFmMod.Down OR tbCreFmFld.Down OR
    tbAMinus.Down OR tbAPlus.Down OR tbSMinus.Down OR
    tbSPlus.Down OR tbHMinus.Down OR tbHPlus.Down OR tbRMinus.Down
    OR tbRPlus.Down);
  acUndoTouch.Enabled := (NOT BUSY) AND (lvMain.SelCount > 0);
  acSelect.Enabled := NOT Busy;
  acReset.Enabled  := NOT Busy;
  tbAMinus.Enabled := NOT Busy;
  tbSMinus.Enabled := NOT Busy;
  tbRMinus.Enabled := NOT Busy;
  tbHMinus.Enabled := NOT Busy;
  tbAPlus.Enabled := NOT Busy;
  tbSPlus.Enabled := NOT Busy;
  tbRPlus.Enabled := NOT Busy;
  tbHPlus.Enabled := NOT Busy;
  tbModFmCre.Enabled := NOT Busy;
  tbModFmFld.Enabled := NOT Busy;
  tbModFmClk.Enabled := (acDate.Checked OR acTime.Checked) AND
    NOT Busy;
  tbCreFmClk.Enabled := (acDate.Checked OR acTime.Checked) AND
    NOT Busy;
  tbCreFmMod.Enabled := NOT Busy;
  tbCreFmFld.Enabled := NOT Busy;
  acNow.Enabled      := NOT Busy;
  acClkFmFile.Enabled := NOT Busy;
  acZerMin.Enabled   := NOT Busy;
  acZerSec.Enabled   := NOT Busy;
  FOR N := 1 TO 5 DO preBtns[N].Enabled := NOT Busy;
end;

procedure TMainForm.acApplyExecute(Sender: TObject);
VAR
  matchList : TStringList; // List of files for folder-match
  N         : Integer;
  Rslt      : Integer;
  D, T      : TDateTime;
  AttrRem   : DWORD; // AND mask for removing attributes
  AttrAdd   : DWORD; // OR mask for adding attributes
  NumTry    : Integer;
  NumBad    : Integer;


  procedure FillFrom(TS : TStringList; const Pth : String);
  // Fill the specified TStringList with the names of all files
  // in the specified path.
  VAR
    FindData : TWin32FindData;
    FindHan  : THandle;
  begin
    TS.Clear;
    FindHan := FindFirstFile(PChar(IncludeTrailingBackslash(Pth)+
      '*.*'), FindData);
    IF FindHan = INVALID_HANDLE_VALUE THEN Exit
    ELSE
      try
        REPEAT
          IF StrComp(FindData.cFilename, '.') = 0 THEN Continue;
          IF StrComp(FindData.cFilename, '..') = 0 THEN Continue;
          TS.Add(FindData.cFileName);
        UNTIL NOT FindNextFile(FindHan, FindData);
        TS.Sort;
      finally
        Windows.FindClose(FindHan);
      end;
  end;

  function AnalyzeList(TS : TStringList) : Boolean;
  // Match the list of filenames with the contents of the main list.
  // Based on the categorization of the files, possibly including
  // a query to the user, return True to proceed, False otherwise.
  VAR
    N          : Integer;
    pMatch     : Integer; // # with perfect matches
    fMatch     : Integer; // # with a unique filename-only match
    mMatch     : Integer; // # with multiple filename-only matches
    xMatch     : Integer; // # with no match at all
    Idx        : Integer;
    JustName   : String;
    TFT        : TftObj;
    toUnselect : Integer;

    procedure UnSelect(cutoff : Integer);
    // If we are proceeding despite having some items that don't
    // de-select those items. The cutoff will be 0 to only remove
    // no-match and multi-match items, or 1 to also remove those
    // with a unique single match.
    VAR N   : Integer;
    begin
      FOR N := 0 TO lvMain.Items.Count-1 DO
        IF lvMain.Items[N].Selected THEN
          IF TFTObj(lvMain.Items[N].Data).MatchStatus <= cutoff THEN
            lvMain.Items[N].Selected := False;
    end;

  begin
    pMatch := 0;
    fMatch := 0;
    mMatch := 0;
    FOR N := 0 TO lvMain.Items.Count-1 DO
      IF lvMain.Items[N].Selected THEN
        begin
          TFT := TFTObj(lvMain.Items[N].Data);
          TFT.MatchStatus := 0;
          IF TS.Find(lvMain.Items[N].Caption, Idx) THEN
            begin // A perfect match
              Inc(pMatch);
              TFT.MatchStatus := 2;
            end
          ELSE
            begin
              JustName := ChangeFileExt(lvMain.Items[N].Caption, '.');
              TS.Find(JustName, Idx);
              // Find returns the place in the list where the just-
              // name portion would be inserted. IF the item at this
              // position does start with the specified name...
              IF (Idx < TS.Count) AND (AnsiStartsText(JustName,
                TS[Idx])) THEN
                begin
                  // IF the next item also starts with the name, we
                  // have a multi-match (bad)
                  IF (Idx < TS.Count-1) AND
                    (AnsiStartsText(JustName, TS[Succ(Idx)])) THEN
                    begin
                      Inc(mMatch);
                      TFT.MatchStatus := 0;
                    end
                  ELSE // We have a unique filename-only match
                    begin
                      Inc(fMatch);
                      TFT.MatchStatus := 1;
                    end;
                end;
            end;
        end;
    xMatch := lvMain.SelCount - (pMatch + fMatch + mMatch);
    // The Ask function returns true if we should proceed, false
    // otherwise. In all but one case, it interacts with the user
    // by building a detailed messagebox.
    Result := Ask(Self.Handle, lvMain.Items.Count, pMatch, fMatch,
      mMatch, xMatch, WasFolder, tbModFmFld.Down, tbCreFmFld.Down,
      toUnselect);
    IF toUnselect >= 0 THEN
      UnSelect(toUnselect);
  end;

  procedure SetMask(bRem, bAdd : Boolean; bit : DWORD);
  begin
    IF bRem      THEN AttrRem := AttrRem AND (NOT bit)
    ELSE IF bAdd THEN AttrAdd := AttrAdd OR bit;
  end;

  procedure Advance(VAR T, D: TDateTime);
  // Advance the time by the specified sequential value. If the
  // time passed 24 hours (i.e. 1.0), bring it back into the
  // 0.0-1.0 range and add one to the date.
  VAR TWas : Extended;
  begin
    TWas := Int(T);
    T := T+SeqValue*c_second;
    IF Int(T) > TWas THEN
      begin
        T := T-1;
        IF D <> 0 THEN
          D := D+1;
      end;
  end;


begin
  // If either of the "from-folder" buttons is down, ask the user
  // which folder and
  IF tbModFmFld.Down OR tbCreFmFld.Down THEN
    begin
      IF GetFolder(Self, WasFolder, 'Select folder for matching '+
        'files', WasFolder) THEN
        begin
          MatchList := TStringList.Create;
          try
            FillFrom(MatchList, WasFolder);
            IF NOT AnalyzeList(MatchList) THEN
              Exit;
          finally
            MatchList.Free;
          end;
        end;
    end;
  IF acDate.Checked THEN D := DTDateMod.Date
  ELSE                   D := -1;
  IF acTime.Checked THEN T := DTTimeMod.Time
  ELSE                   T := -1;
  // Build the add/remove attribute masks
  AttrRem := DWORD(-1);
  AttrAdd := DWORD(0);
  SetMask(tbAMinus.Down, tbAPlus.Down, FILE_ATTRIBUTE_ARCHIVE);
  SetMask(tbSMinus.Down, tbSPlus.Down, FILE_ATTRIBUTE_SYSTEM);
  SetMask(tbHMinus.Down, tbHPlus.Down, FILE_ATTRIBUTE_HIDDEN);
  SetMask(tbRMinus.Down, tbRPlus.Down, FILE_ATTRIBUTE_READONLY);
  NumBad := 0;
  NumTry := 0;
  Screen.Cursor := crHourglass;
  SetBusy(True);
  try
    FOR N := 0 TO lvMain.Items.Count-1 DO
      begin
        IF NOT lvMain.Items[N].Selected THEN Continue;
        Inc(NumTry);
        WITH tftObj(lvMain.Items[N].Data) DO
          begin
            IF tbModFmClk.down THEN // mod from clock
              SetModPendingOpt(D, T)
            ELSE IF tbModFmCre.Down THEN // mod from cre
              ModPending := CreTime;
            IF tbCreFmClk.Down THEN // cre from clock
              SetCrePendingOpt(D, T)
            ELSE IF tbCreFmMod.Down THEN // mod from cre
              CrePending := ModTime;
            SetFromFolder(WasFolder, tbModFmFld.Down, tbCreFmFld.Down);
            IF (tbModFmClk.down OR tbCreFmClk.Down) AND
              (acSeq.Checked AND acSeq.Enabled) THEN
              Advance(T, D);
            IF (AttrRem <> DWORD(-1)) OR (AttrAdd <> DWORD(0)) THEN
              AttrChange(AttrRem, AttrAdd);
            // **** HERE **** is where the action is. PerformPending
            // applies the other changes that have been set up by the
            // lines preceding
            Rslt := PerformPending;
            // ********************
            IF (Rslt = -1) OR (Rslt = 0) THEN
              lvMain.Items[N].ImageIndex := 1
            ELSE
              begin
                lvMain.Items[N].ImageIndex := 2;
                Inc(NumBad);
              end;
            IF Rslt AND err_file = 0 THEN
              lvMain.Items[N].Caption := ExtractFilename(Filename);
            IF Rslt AND err_mod = 0 THEN
              lvMain.Items[N].SubItems[pred(c_mod)] := SModTime;
            IF Rslt AND err_cre = 0 THEN
              lvMain.Items[N].SubItems[pred(c_cre)] := SCreTime;
            IF Rslt AND err_att = 0 THEN
              lvMain.Items[N].SubItems[pred(c_att)] := SAttr;
          end;
      end;
    IF NumBad > 0 THEN
      MessageBox(Handle, PChar(Format('FileTouch was unable to '+
        'touch %d of %d file%s. A red icon indicates a problem file. '+
        'Move the mouse over the red icon for more information.',
        [NumBad, NumTry, ss[NumTry > 1]])),
        PChar(Application.Title), MB_OK OR MB_ICONSTOP);
  finally
    Screen.Cursor := crDefault;
    SetBusy(False);
    aeMainHint(aeMain);
  end;
end;

procedure TMainForm.acUndoTouchExecute(Sender: TObject);
// Reset each selected item back to its original values before
// any number of Touch operations.
VAR
  N      : Integer;
  Rslt   : Integer;
  NumBad : Integer;
  NumTry : Integer;
begin
  NumBad := 0;
  NumTry := 0;
  Screen.Cursor := crHourglass;
  SetBusy(True);
  try
    FOR N := 0 TO lvMain.Items.Count-1 DO
      begin
        IF NOT lvMain.Items[N].Selected THEN Continue;
        Inc(NumTry);
        WITH tftObj(lvMain.Items[N].Data) DO
          begin
            Rslt := Undo;
            IF Rslt = 0 THEN
              lvMain.Items[N].ImageIndex := 0
            ELSE
              begin
                lvMain.Items[N].ImageIndex := 3;
                Inc(NumBad);
              end;
            IF Rslt AND err_file = 0 THEN
              lvMain.Items[N].Caption := ExtractFilename(Filename);
            IF Rslt AND err_mod = 0 THEN
              lvMain.Items[N].SubItems[pred(c_mod)] := SModTime;
            IF Rslt AND err_cre = 0 THEN
              lvMain.Items[N].SubItems[pred(c_cre)] := SCreTime;
            IF Rslt AND err_att = 0 THEN
              lvMain.Items[N].SubItems[pred(c_att)] := SAttr;
          end;
      end;
    IF NumBad > 0 THEN
      MessageBox(Handle, PChar(Format('FileTouch was unable to '+
        'undo %d of %d file%s. A red icon indicates a problem file. '+
        'Move the mouse over the red icon for more information.',
        [NumBad, NumTry, ss[NumTry > 1]])),
        PChar(Application.Title), MB_OK OR MB_ICONSTOP);
  finally
    Screen.Cursor := crDefault;
    SetBusy(False);
    aeMainHint(aeMain);
  end;
end;

procedure TMainForm.acResetExecute(Sender: TObject);
// Set all the controls to default values
VAR N : Integer;
begin
  FOR N := 0 TO ComponentCount-1 DO
    IF Components[N] IS TToolButton THEN
      WITH TToolButton(Components[N]) DO
        IF (Parent.Parent = gbAttr) OR (Parent.Parent = gbSettings) THEN
          Down := False;
  acDate.Checked := True;
  acTime.Checked := True;
  acSeq.Checked  := False;
  EnDisDateTime;
end;

procedure TMainForm.LabelsClick(Sender: TObject);
// This method handles both click and double-click for the labels
// assigned to the six settings toolbars. Each click cycles thru
// the possible states.
begin
  WITH Sender AS TLabel DO
    CycleButtons(FocusControl AS TToolBar);
end;

procedure TMainForm.DTDateModDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
// The user can drag a file onto the date/time pickers to set them
// from that file's Modified date/time stamp
begin
  Accept := (Source = lvMain) AND (Dragee <> nil);
end;

procedure TMainForm.DTDateModDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  ClockFromFile(TFTObj(dragee.data).Filename);
end;

procedure TMainForm.comSeqNChange(Sender: TObject);
// When either of the sequential-time comboboxes changes, we
// recalculate the number of seconds
begin
  SeqValue := StrToIntDef(comSeqN.Text, 1);
  IF comSeqU.ItemIndex > 0 THEN
    SeqValue := SeqValue * 60;
end;

procedure TMainForm.tbPreAll(Sender: TObject);
// The Presets buttons do the same as Apply if configured; they
// do the same as Configure if not.
begin
  WITH Sender AS TToolButton DO
    IF preApps[Tag].Enabled THEN
      preA_AllExecute(preApps[Tag])
    ELSE
      preC_AllExecute(preCnfs[Tag]);
end;

function MySortProc(lParam1, lParam2 : TListItem;
  lParamSort: Integer): Integer stdcall;
// Used in sorting the listview
VAR TFT1, TFT2 : TFtObj;
begin
  TFT1 := TFTObj(lParam1.Data);
  TFT2 := TFTObj(lParam2.Data);
  CASE Pred(Abs(lParamSort)) OF
    c_name : Result := 0;
    c_mod  : Result := CompFileTime(TFT1.ModTime, TFT2.ModTime);
    c_cre  : Result := CompFileTime(TFT1.CreTime, TFT2.CreTime);
    c_att  : Result := AnsiCompareText(lParam1.SubItems[c_att-1],
      lParam2.SubItems[c_att-1]);
    c_path : Result := AnsiCompareText(lParam1.SubItems[c_path-1],
      lParam2.SubItems[c_path-1]);
    ELSE Result := 0;
  END;
  // IF otherwise equal, sort by filename
  IF Result = 0 THEN
    Result := AnsiCompareText(lParam1.Caption, lParam2.Caption);
  IF lParamSort < 0 THEN
    Result := -Result;
end;

procedure TMainForm.lvMainColumnClick(Sender: TObject;
  Column: TListColumn);
VAR N : Integer;
begin
  IF Succ(Column.Index) = Abs(SortCol) THEN
    SortCol := -SortCol
  ELSE
    SortCol := Succ(Column.Index);
  lvMain.CustomSort(@MySortProc, SortCol);
  FOR N := 0 TO lvMain.Columns.Count-1 DO
    WITH lvMain.Columns[N] DO
      IF Tag = Abs(SortCol) THEN
        IF SortCol > 0 THEN
          SetColImage(lvMain, Tag-1, 4)
        ELSE
          SetColImage(lvMain, Tag-1, 5)
      ELSE
        SetColImage(lvMain, Tag-1, 0);
  IF lvMain.Selected <> nil THEN
    lvMain.Selected.MakeVisible(False);
end;

procedure TMainForm.lvMainCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState;
  var DefaultDraw: Boolean);
// Use italic for folders
begin
  IF Item = nil THEN Exit;
  IF Item.Data = nil THEN Exit;
  IF TFTObj(Item.Data).Attr AND FILE_ATTRIBUTE_DIRECTORY = 0 THEN
    TListView(Sender).Canvas.Font.Style := []
  ELSE
    TListView(Sender).Canvas.Font.Style := [fsItalic];
end;

procedure TMainForm.lvMainDragOver(Sender, Source: TObject;
  X, Y: Integer; State: TDragState; var Accept: Boolean);
// The user can drag to re-order items
begin
  Accept := (Source = Sender) AND (Dragee <> nil);
end;

procedure TMainForm.lvMainDragDrop(Sender, Source: TObject;
  X, Y: Integer);
VAR
  Dropee : TListItem;
  Idx    : Integer;
begin
  Dropee := (Sender AS TListView).DropTarget;
  IF Dropee = nil THEN Exit;
  IF Dropee = Dragee THEN Exit;
  Idx := Dropee.Index;
  // If the dragee came from "above" the dropee, increment the index
  IF Dragee.Index < Idx THEN Inc(Idx);
  WITH (Sender AS TListView).Items.Insert(Idx) DO
    begin
      Assign(Dragee);
      Selected := True;
      Focused := True;
    end;
  Dragee.Delete;
  Dragee := nil;
  NoSortCol;
end;

procedure TMainForm.lvMainInfoTip(Sender: TObject; Item: TListItem;
  var InfoTip: String);
// Set the infotip to the item's status. Status will be non-blank
// if the item has been touched (successfully or not) or if it has
// failed an Undo operation.
begin
  IF Item = nil THEN
    InfoTip := ''
  ELSE
    WITH TFTObj(Item.Data) DO
      CASE Item.ImageIndex OF
        1, 2 : InfoTip := 'Touched status:'#13#10 + Status;
        3 :    InfoTip := 'Undo status:'#13#10+ Status;
        ELSE   InfoTip := '';
      END;
end;

procedure TMainForm.lvMainSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
// Update the default hint to indicate the number selected
begin
  aeMainHint(aeMain);
end;

procedure TMainForm.lvMainStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  Dragee := lvMain.Selected;
end;

procedure TMainForm.aeMainHint(Sender: TObject);
VAR S : String;
begin
  IF (Application.Hint = '') AND (NOT PresetForm.Visible) THEN
    S := Format(' %d files, %d selected.',
      [lvMain.Items.Count, lvMain.Selcount])
  ELSE S := ' ' + Application.Hint;
  IF Screen.ActiveForm = PresetForm THEN
    PresetForm.sbPre.SimpleText := S
  ELSE
    sbMain.SimpleText := S;
end;

procedure TMainForm.aeMainSettingChange(Sender: TObject;
  Flag: Integer; const Section: String; var Result: Integer);
// Set the form's font to the system's meessagebox font and
// the listview's font to the system's icon title font
VAR
  NCM : NONCLIENTMETRICS;
  ICM : ICONMETRICS;
  F   : TFont;

  procedure FixTBS;
  // Delphi doesn't automatically size/move floating toolbars to
  // account for large fonts. This routine aligns the various
  // controls, and handles changes in MessageBox font.
    procedure Fixup(TB : TToolBar; TL : TLabel);
    begin
      TB.Left := TB.Parent.Width - TB.Width - 8;
      TB.Top  := TL.Top + TL.Height - TB.Height + 2;
      TL.Left := TB.Left - TL.Width - 8;
    end;

    procedure CenterC(TC : TControl);
    begin
      TC.Left := (TC.Parent.ClientWidth - TC.Width) DIV 2;
    end;

  begin
    Fixup(tbAttrA, lblA);
    Fixup(tbAttrS, lblS);
    Fixup(tbAttrH, lblH);
    Fixup(tbAttrR, lblR);
    tbClkA.Left := DTTimeMod.Left;
    tbClkB.Left := DTTimeMod.Left + DTTimeMod.Width - tbClkB.Width;
    // Center the two toolbars in the Date/time box vertically
    tbClkA.Top  := (DTTimeMod.Top + DTTimeMod.Height + ComSeqN.Top -
      tbClkA.Height) DIV 2;
    tbClkB.Top  := tbClkA.Top;
    CenterC(tbMod);
    CenterC(tbCre);
    CenterC(tbFiles);
    CenterC(tbTouch);
    CenterC(lblM);
    CenterC(lblC);
    CenterC(lblFilA);
    CenterC(lblFilT);
    // Align various elements in horizontal rows
    lblM.Top      := lblA.Top;
    tbMod.Top     := tbAttrS.Top;
    lblC.Top      := lblH.Top;
    tbCre.Top     := tbAttrR.Top;
    lblFilA.Top   := lblA.Top;
    tbFiles.Top   := tbAttrS.Top;
    lblFilT.Top   := lblH.Top;
    tbTouch.Top   := tbAttrR.Top;
    // Bottom-align the presets toolbar with the pushbuttons
    tbPresets.Top := btnHelp.Top + btnHelp.Height - tbPresets.Height
      + 2;
  end;

begin
  F := TFont.Create;
  try
    FillChar(NCM, SizeOf(NCM), 0);
    NCM.cbSize := SizeOf(NCM);
    SystemParametersInfo(SPI_GETNONCLIENTMETRICS, SizeOf(NCM), @NCM,
      0);
    F.Handle := CreateFontIndirect(NCM.lfMessageFont);
    IF (F.Name <> Self.Font.Name) OR (F.Size<>Self.Font.Size) THEN
      begin
        F.Style := [];
        Self.Font.Assign(F);
        Self.Canvas.Font := Self.Font;
        sbMain.Height := Self.Canvas.TextHeight('Ay') + 6;
        fixTBs;
      end
    ELSE IF FirstTime THEN
      begin
        FixTBs;
        FirstTime := False;
      end;
    FillChar(ICM, SizeOf(ICM), 0);
    ICM.cbSize := SizeOf(ICM);
    SystemParametersInfo(SPI_GETICONMETRICS, SizeOf(ICM), @ICM,
      0);
    F.Handle := CreateFontIndirect(ICM.lfFont);
    IF (F.Name <> lvMain.Font.Name) OR (F.Size<>lvMain.Font.Size) THEN
      begin
        F.Style := [];
        lvMain.Font.Assign(F);
      end;
    ColExtra := lvMain.Canvas.TextWidth('AM');
    FixColumns;
  finally
    F.Free;
  end;
end;

procedure TMainForm.FlyoverMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// This method exists to enable flyover help for disabled controls
VAR
  P : TPoint;
  N : Integer;
begin
  P := Point(X, Y);
  WITH Sender AS TWinControl DO
    begin
      Hint := '';
      FOR N := 0 TO ControlCount-1 DO
        IF Controls[N] IS TWinControl THEN
          IF PtInRect(TWinControl(Controls[N]).BoundsRect, P) THEN
            Hint := TWinControl(Controls[N]).Hint;
      IF Hint = '' THEN
        begin
          IF (Sender AS TWinControl).Tag = 1 THEN
            Hint := '|Click a button to select; click again to '+
              'de-select'
          ELSE
            Application.CancelHint;
        end;
    end;
end;

procedure TMainForm.AddAnItem(const filename: String; vCreTime,
  vModTime: TFileTime; vAttr : DWord);
VAR
  LVI : TListItem;
  TFT : TftObj;
  N   : Integer;
  Idx : Integer;
begin
  // IF the name is already on our list use the existing item. If
  // not, create a new item
  Idx := DupeList.IndexOf(filename);
  IF Idx >= 0 THEN
    LVI := TListItem(DupeList.Objects[Idx])
  ELSE
    // If we didn't find an existing item matching the filename,
    // create a new one and initialize its subitems with blanks.
    // That way we can use the same code to assign values to the
    // new item's subitems or to an existing one.
    begin
      LVI := lvMain.Items.Add;
      DupeList.AddObject(filename, LVI);
      FOR N := 1 TO lvMain.Columns.Count-1 DO
        LVI.SubItems.Add('');
    end;
  TFT := TftObj.Create(vAttr, filename, vCreTime, vModTime);
  LVI.Data       := TFT;
  LVI.Caption    := ExtractFileName(filename);
  LVI.ImageIndex := 0;
  LVI.SubItems[pred(c_mod)]  := TFT.SModTime;
  LVI.SubItems[pred(c_cre)]  := TFT.SCreTime;
  LVI.SubItems[pred(c_path)] := ExtractFileDir(filename);
  LVI.SubItems[pred(c_att)]  := TFT.SAttr;
  LVI.Selected := True;
end;

function TMainForm.Ask(mbHandle : HWnd; total, pMatch, fMatch,
  mMatch, xMatch: Integer; const WasFolder : String;  vMod,
  vCre : Boolean; VAR UnSelect : Integer) : Boolean;
// This monster function takes the results of the from-folders
// analysis and builds a messagebox with the appropriate text
// and buttons to get any necessary user input. If every file
// has a perfect match, it skips the message box and returns
// true.
CONST
  xxStr = 'No matching filenames, so no changes will be made.';
  MB_YNC = MB_HELP OR MB_YESNOCANCEL OR MB_ICONQUESTION;
  MB_OKC = MB_HELP OR MB_OKCANCEL OR MB_ICONQUESTION;
  MB_XXX = MB_HELP OR MB_OK OR MB_ICONSTOP;
VAR
  Msg : String;
  MBP : MsgBoxParams;

  function StringFor(Num : Integer; const Fmt : String) : String;
  const names : ARRAY[1..9] OF String =
    ('One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven',
     'Eight', 'Nine');
  begin
    IF Num = total THEN
      Result := ' - All files have '+Fmt
    ELSE
      CASE Num OF
        0 : Result := ' - No files have '+Fmt;
        1 : Result := ' - One file has '+Fmt;
        ELSE
          begin
            IF Num < 10 THEN
              Result := ' - '+names[Num] +' files have '+Fmt
            ELSE
              Result := ' - '+IntToStr(Num) +' files have '+Fmt;
          end;
      END;
    Result := Result + #13#10;
  end;

  function pStr : String;
  begin
    Result := StringFor(pMatch, 'an exact match in both file name '+
      'and type.');
  end;

  function fStr : String;
  begin
    Result := StringFor(fMatch, 'a match in file name but not '+
      'type.');
  end;

  function mStr : String;
  begin
    Result := StringFor(mMatch, 'multiple matches of file name but '+
      'not type; these will not be processed.');
  end;

  function xStr : String;
  begin
  xStr := StringFor(xMatch, 'no match at all; these will not be '+
    'processed.');
  end;

  function Ending : String;
  begin
    IF vMod THEN
      IF vCre THEN
        Result := 'Modified and Created'
      ELSE Result := 'Created'
    ELSE Result := 'Modified';
    Result := #13#10'The '+Result+' date/time stamp of the '+
      'selected file(s) will be changed to that of matching files '+
      'in this folder.'#13#10;
  end;

  function yncStr : String;
  begin
    Result := Ending+#13#10'Click Yes'#9#9'to process name-only '+
      'matches as well as exact matches.'#13#10'Click No'#9#9+
      'to process only exact matches.'#13#10'Click Cancel'#9+
      'to do neither.';
  end;

  function ynStr : String;
  begin
    Result := Ending+#13#10+'Click OK to process the matching '+
      'files.';
  end;

begin
  FillChar(MBP, SizeOf(MBP), 0);
  MBP.cbSize := SizeOf(MBP);
  MBP.hwndOwner := mbHandle;
  MBP.hInstance := hInstance;
  MBP.lpszCaption := PChar(Application.Title);
  MBP.dwContextHelpId := 42;
  Result := False;
  UnSelect := -1;
  Msg := Format('A comparison of the selected file(s) with the '+
    'contents of the folder %s finds:'#13#10#13#10,
    [ExcludeTrailingBackslash(WasFolder)]);
  IF pMatch > 0 THEN
    IF fMatch > 0 THEN
      IF mMatch > 0 THEN
        IF xMatch > 0 THEN
          begin // hasMatch, hasFile, hasMulti, hasNo
            Msg := Msg + pStr + fStr + mStr + xStr + yncStr;
            MBP.dwStyle := MB_YNC;
          end
        ELSE
          begin // hasMatch, hasFile, hasMulti
            Msg := Msg + pStr + fStr + mStr + yncStr;
            MBP.dwStyle := MB_YNC;
          end
      ELSE
        IF xMatch > 0 THEN
          begin // hasMatch, hasFile, hasNo
            Msg := Msg + pStr + fStr + xStr + yncStr;
            MBP.dwStyle := MB_YNC;
          end
        ELSE
          begin // hasMatch, hasFile
            Msg := Msg + pStr + fStr + yncStr;
            MBP.dwStyle := MB_YNC;
          end
    ELSE
      IF mMatch > 0 THEN
        IF xMatch > 0 THEN
          begin // hasMatch, hasMulti, hasNo
            Msg := Msg + pStr + mStr + xStr + ynStr;
            MBP.dwStyle := MB_OKC;
          end
        ELSE
          begin // hasMatch, hasMulti
            Msg := Msg + pStr + mStr + ynStr;
            MBP.dwStyle := MB_OKC;
          end
      ELSE
        IF xMatch > 0 THEN
          begin // hasMatch, hasNo
            Msg := Msg + pStr + xStr + ynStr;
            MBP.dwStyle := MB_OKC;
          end
        ELSE
          begin // hasMatch ONLY - YAZOO!
            Result := True;
            Exit;
          end
  ELSE // no match
    IF fMatch > 0 THEN
      IF mMatch > 0 THEN
        IF xMatch > 0 THEN
          begin // hasFile, hasMulti, hasNo
            Msg := Msg + fStr + mStr + xStr + ynStr;
            MBP.dwStyle := MB_OKC;
          end
        ELSE
          begin // hasFile, hasMulti
            Msg := Msg + fStr + mStr + ynStr;
            MBP.dwStyle := MB_OKC;
          end
      ELSE
        IF xMatch > 0 THEN
          begin // hasFile, hasNo
            Msg := Msg + fStr + xStr + ynStr;
            MBP.dwStyle := MB_OKC;
          end
        ELSE
          begin // hasFile
            Msg := Msg + fStr + ynStr;
            MBP.dwStyle := MB_OKC;
          end
    ELSE
      IF mMatch > 0 THEN
        IF xMatch > 0 THEN
          begin // hasMulti, hasNo
            Msg := Msg + mStr + xStr;
            MBP.dwStyle := MB_XXX;
          end
        ELSE
          begin // hasMulti
            Msg := Msg + mStr;
            MBP.dwStyle := MB_XXX;
          end
      ELSE
        IF xMatch > 0 THEN
          begin // hasNo
            Msg := Msg + xxStr;
            MBP.dwStyle := MB_XXX;
          end
        ELSE
          begin // nothing
            Result := False; // Not possible
            Exit;
          end;
  MBP.lpszText := PChar(Msg);
  // The Yes/No/Cancel message lets the user choose to process
  // name-only matches as well as exact matches (Yes), process
  // only exact matches (No), or do nothing (Cancel)
  IF MBP.dwStyle = MB_YNC THEN
    begin
      CASE Integer(MessageBoxIndirect(MBP)) OF
        idYes : begin
          UnSelect := 0;
          Result := True;
        end;
        idNo : begin
          UnSelect := 1;
          Result := True;
        end;
        ELSE Result := False;
      end;
    end
  // The OK/Cancel box lets the user confirm that it's OK to
  // process the files that have matches and skip the rest
  ELSE IF MBP.dwStyle = MB_OKC THEN
    begin
      Result := Integer(MessageBoxIndirect(MBP)) = idOK;
      IF Result THEN
        UnSelect := 0;
    end
  // The just-OK box tells the user there's nothing to do
  ELSE IF MBP.dwStyle = MB_XXX THEN
    begin
      Result := False;
      MessageBoxIndirect(MBP);
    end;
end;

procedure TMainForm.CheckShared;
VAR
  hMap : THandle;
  PH   : PShared;
  TS   : TStringList;
  N    : Integer;

  procedure AddFiles(const S : String);
  VAR
    FindHan  : THandle;
    FindData : TWin32FindData;
    Path     : String;
  begin
    Path := ExpandFileName(S);
    FindHan := FindFirstFile(PChar(Path), FindData);
    Path := IncludeTrailingBackslash(ExtractFileDir(Path));
    IF FindHan = INVALID_HANDLE_VALUE THEN Exit
    ELSE
      try
        REPEAT
          IF StrComp(FindData.cFilename, '.') = 0 THEN Continue;
          IF StrComp(FindData.cFilename, '..') = 0 THEN Continue;
          AddAnItem(Path+FindData.cFileName, FindData.ftCreationTime,
            FindData.ftLastWriteTime, FindData.dwFileAttributes);
        UNTIL NOT FindNextFile(FindHan, FindData);
      finally
        Windows.FindClose(FindHan);
      end;
  end;

  procedure SetSwitches(T : TShared);
  begin
    IF T.Preset > 0 THEN
      preA_AllExecute(preApps[T.Preset])
    ELSE
      begin
        acDate.Checked := T.ExDate;
        acDateExecute(acDate);
        acTime.Checked := T.ExTime;
        acTimeExecute(acTime);
        acSeq.Checked := T.Seq = 0;
        acSeqExecute(acSeq);
        CASE T.Seq OF
          0 : ;
          1       : comSeqN.ItemIndex := 0;
          2       : comSeqN.ItemIndex := 1;
          3..5    : comSeqN.ItemIndex := 2;
          6..10   : comSeqN.ItemIndex := 3;
          11..20  : comSeqN.ItemIndex := 4;
          21..30  : comSeqN.ItemIndex := 5;
          ELSE
            begin
              comSeqU.ItemIndex := 1;
              CASE T.Seq DIV 60 OF
                0..1    : comSeqN.ItemIndex := 0;
                2       : comSeqN.ItemIndex := 1;
                3..5    : comSeqN.ItemIndex := 2;
                6..10   : comSeqN.ItemIndex := 3;
                11..20  : comSeqN.ItemIndex := 4;
                ELSE      comSeqN.ItemIndex := 5;
              END;
            end;
        end;
        IF T.SetDate > -1 THEN
          DTDateMod.Date := T.SetDate;
        IF T.SetTime > -1 THEN
          DTTimeMod.Time := T.SetTime;
        IF T.ZerSec THEN acZerSecExecute(acZerSec);
        IF T.ZerMin THEN acZerMinExecute(acZerMin);
        CASE T.AtA OF
          -1 : tbAMinus.Down := True;
          1  : tbAPlus.Down := True;
        END;
        CASE T.AtS OF
          -1 : tbSMinus.Down := True;
          1  : tbSPlus.Down := True;
        END;
        CASE T.AtH OF
          -1 : tbHMinus.Down := True;
          1  : tbHPlus.Down := True;
        END;
        CASE T.AtR OF
          -1 : tbRMinus.Down := True;
          1  : tbRPlus.Down := True;
        END;
        CASE T.ModAct OF
          c_fromSys   : tbModFmClk.Down := True;
          c_fromOther : tbModFmCre.Down := True;
        END;
        CASE T.CreAct OF
          c_fromSys   : tbCreFmClk.Down := True;
          c_fromOther : tbCreFmMod.Down := True;
        END;
      end;
  end;

begin
  hMap := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, MainMapName);
  IF hMap = 0 THEN Exit;
  try
    PH := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
    IF PH = nil THEN Exit;
    try
      IF PH^.Specs <> '' THEN
        begin
          TS := TStringList.Create;
          try
            TS.Text := PH^.Specs;
            FOR N := 0 TO TS.Count-1 DO
              AddFiles(TS[N]);
          finally
            TS.Free;
          end;
        end;
      IF PH^.AnySwitch THEN
        SetSwitches(PH^);
    finally
      UnMapViewOfFile(PH);
    end;
  finally
    CloseHandle(hMap);
  end;
end;

procedure TMainForm.ClockFromFile(const filename: String);
// Set the date control, time control, or both from the Modified
// date/time of the specified file
VAR
  vCre  : TFileTime;
  vMod  : TFileTime;
begin
  IF GetFileDateTimes(filename, vCre, vMod) THEN
    begin
      IF acDate.Checked THEN
        DTDateMod.DateTime := TftObj.FileTime2TDateTime(vMod);
      IF acTime.Checked THEN
        DTTimeMod.DateTime := DTDateMod.DateTime;
    end;
end;

procedure TMainForm.EnDisDateTime;
// Enable and disable the controls in the date/time box based on
// the status of the three checkboxes.
begin
  acDate.Enabled    := NOT BUSY;
  acTime.Enabled    := NOT BUSY;
  dtDateMod.Enabled := (NOT BUSY) AND acDate.Checked;
  dtTimeMod.Enabled := (NOT BUSY) AND acTime.Checked;
  acSeq.Enabled     := acDate.Checked AND acTime.Checked;
  comSeqN.Enabled   := acSeq.Enabled AND acSeq.Checked;
  comSeqU.Enabled   := acSeq.Enabled AND acSeq.Checked;
  IF acDate.Checked OR acTime.Checked THEN
    begin
      tbModFmClk.Enabled := NOT BUSY;
      tbCreFmClk.Enabled := NOT BUSY;
    end
  ELSE
    begin
      WITH tbModFmClk DO
        begin
          Down := False;
          Enabled := False;
        end;
      WITH tbCreFmClk DO
        begin
          Down := False;
          Enabled := False;
        end;
    end;
end;

procedure TMainForm.FixColumns;
VAR N : Integer;
begin
  IF lvMain.Items.Count = 0 THEN
    FOR N := 0 TO lvMain.Columns.Count-1 DO
      begin
        SendMessage(lvMain.Handle, LVM_SETCOLUMNWIDTH, N,
          LVSCW_AUTOSIZE_USEHEADER);
        lvMain.Columns[N].MinWidth := SendMessage(lvMain.Handle,
          LVM_GETCOLUMNWIDTH, N, 0) + ColExtra;
      end
  ELSE
    FOR N := 0 TO lvMain.Columns.Count-1 DO
      begin
        // Get the minimum width needed for the column's contents
        SendMessage(lvMain.Handle, LVM_SETCOLUMNWIDTH, N,
          LVSCW_AUTOSIZE);
        lvMain.Columns[N].Width := SendMessage(lvMain.Handle,
          LVM_GETCOLUMNWIDTH, N, 0) + ColExtra;
      end;
end;

procedure TMainForm.NoSortCol;
// If the user adds files or re-orders them, the sort order is no
// longer valid, so clear it internally and visually
VAR N : Integer;
begin
  IF SortCol = 0 THEN Exit;
  SortCol := 0;
  FOR N := 0 TO lvMain.Columns.Count-1 DO SetColImage(lvMain, N, 0);
end;

procedure TMainForm.SetBusy(value : Boolean);
begin
  Busy := value;
  acRemoveUpdate  (acRemove);
  acItemDownUpdate(acItemDown);
  acApplyUpdate   (acApply);
  EnDisDateTime;
  Application.ProcessMessages;
end;

procedure TMainForm.SetColImage(LV : TListView; col, Idx : Integer);
// Change a listview column's image without going through TListColumn
// (because that forces other properties to be reset)
VAR L : LV_COLUMN;
begin
  FillChar(L, SizeOf(L), 0);
  IF SendMessage(LV.Handle, LVM_GETCOLUMN, col,Integer(@L)) <> 0 THEN
    begin
      L.Mask   := LVCF_IMAGE;
      L.iImage := Idx;
      SendMessage(LV.Handle, LVM_SETCOLUMN, col, Integer(@L));
    end;
end;

function TMainForm.ZerTime(T : TDateTime; MinToo : Boolean)
  : TDateTime;
VAR Ye, Mo, Da, Ho, Mi, Se, Ms : Word;
begin
  DecodeDate(T, Ye, Mo, Da);
  DecodeTime(T, Ho, Mi, Se, Ms);
  IF MinToo THEN
    Result := EncodeDate(Ye, Mo, Da) + EncodeTime(Ho, 0, 0, 0)
  ELSE
    Result := EncodeDate(Ye, Mo, Da) + EncodeTime(Ho, Mi, 0, 0);
end;

procedure TMainForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
// Prevent the main window from getting TOO small
begin
  WITH Msg.MinMaxInfo.ptMinTrackSize DO
    begin
      IF MinWid = 0 THEN
        X := 640
      ELSE X := MinWid;
      Y := 400;
    end;
  Msg.Result := 0;
end;

procedure TMainForm.WM_HELP(var Msg: TWMHelp);
// Handle the WM_HELP message that comes from the Ask method's
// message box.
begin
  IF Msg.HelpInfo^.dwContextId = 42 THEN
    Application.HelpContext(12);
  Inherited;
end;

procedure TMainForm.WM_HEYYOU(var Msg: TMessage);
begin
  CheckShared;
end;

{ TListView }

procedure TListView.WMDropFiles(var Msg: TWMDropFiles);
VAR
  NetWork  : TStringList;
  CDROM    : TStringList;
  Num      : Integer;
  N        : Integer;
  filename : String;
  Drive    : String;
  Mapped   : String;
  vCre     : TFileTime;
  vMod     : TFileTime;
  Attr     : DWord;
begin
  NetWork            := TStringList.Create;
  NetWork.Sorted     := True;
  NetWork.Duplicates := dupIgnore;
  CDROM              := TStringList.Create;
  CDROM.Sorted       := True;
  CDROM.Duplicates   := dupIgnore;
  Screen.Cursor      := crHourglass;
  MainForm.SetBusy(True);
  try
    Num := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
    FOR N := 0 TO Num-1 DO
      begin
        SetLength(filename, MAX_PATH);
        SetLength(filename, DragQueryFile(Msg.Drop, N,
          PChar(filename), MAX_PATH));
        Filename := trim(filename);
        IF Filename = '' THEN Continue;
        Drive := IncludeTrailingBackslash(ExtractFileDrive(Filename));
        CASE GetDriveType(PChar(Drive)) OF
          DRIVE_REMOTE : begin
            Mapped := GetRemote(Drive);
            IF Mapped = Drive THEN
              NetWork.Add(#9+Drive)
            ELSE Network.Add(Format(#9'%s (mapped to %s)',
              [Mapped, Drive]));
          end;
          DRIVE_CDROM : begin
            CDROM.Add(Drive);
          end;
          ELSE IF GetFileDateTimes(Filename, vCre, vMod, Attr) THEN
            MainForm.AddAnItem(filename, vCre, vMod, Attr);
        END;
      end;
  finally
    IF NetWork.Count > 0 THEN
      begin
        MessageBox(Self.Handle, PChar(Format('You have selected '+
          'one or more files from the following Network drive%s:'+
          #13#10'%s'#13#10'FileTouch only works with files on '+
          'local drives. Please run FileTouch on the machine that '+
          'contains the drive%0:s listed above.',
          [ss[NetWork.Count > 1], NetWork.Text])),
          PChar(Application.Title),
          MB_OK OR MB_ICONSTOP);
      end;
    IF CDROM.Count > 0 THEN
      begin
        Drive := StringReplace(CDROM.Text, #13#10, ', ',
          [rfReplaceAll]);
        IF AnsiEndsText(', ', Drive) THEN
          SetLength(Drive, Length(Drive) - 2);
        MessageBox(Self.Handle, PChar(Format('You have selected '+
          'one or more files from the CD-ROM drive%s %s. '+
          'FileTouch cannot modify files on a CD-ROM.',
          [ss[CDROM.Count > 1], Drive])), PChar(Application.Title),
          MB_OK OR MB_ICONSTOP);
      end;
    Screen.Cursor      := crDefault;
    MainForm.SetBusy(False);
    NetWork.Free;
    CDROM.Free;
    DragFinish(Msg.Drop);
    MainForm.FixColumns;
  end;
end;

{ TDateTimePicker }

procedure TDateTimePicker.WMDropFiles(var Msg: TWMDropFiles);
VAR Filename : String;
begin
  IF DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0) > 0 THEN
    begin
      SetLength(filename, MAX_PATH);
      SetLength(filename, DragQueryFile(Msg.Drop, 0, PChar(filename),
        MAX_PATH));
      Filename := trim(filename);
      IF Filename <> '' THEN
        MainForm.ClockFromFile(Filename);
    end;
end;

end.
